

package particles

import ("project-particles/config"
        "math/rand"
        "math"
		    "time")

/*une méthode qui donne une durée de vie à une particule , et en option on peut la
rendre de plus en plus opaque au fur et à mesure du temps pour rajouter un style.*/

func (p *Particle)Vie()  {

    if config.General.DureevieActive{

        if p.Dureevie > 0{
        p.Dureevie = p.Dureevie - 1
        p.Opacity = p.Opacity * config.General.OpacityDDV
        if p.Dureevie == 0{
          p.Death = true
        }
      }
    }
  }

/*une méthode qui active la gravité pour cela la valeur de la gravité est
additionné à la PositionY */

func (p *Particle)Gravitee() {

    if config.General.LimiteActive{

      if p.PositionX < float64(config.General.WindowSizeX)+config.General.LimiteX && p.PositionX > 0 && p.PositionY < float64(config.General.WindowSizeY)+config.General.LimiteY && p.PositionY > 0 {

        p.PositionY = p.PositionY + config.General.Gravite
      }
    }else{
        p.PositionY = p.PositionY + config.General.Gravite
    }
}

// Une méthode qui fait rebondir les particules sur les bords de l'écran

func (p *Particle)Rebondis(){

    if p.PositionX + p.ScaleX > float64(config.General.WindowSizeX){
      p.SpeedX = p.SpeedX * -1
    }
    if p.PositionY + p.ScaleY> float64(config.General.WindowSizeY){
      p.SpeedY = p.SpeedY * -1
    }

    if p.PositionX < 0{
      p.SpeedX = p.SpeedX * -1
    }
    if p.PositionY < 0{
      p.SpeedY = p.SpeedY * -1
    }
}

/* une méthode qui fait des changements de couleurs (Red, Green, Blue),
d'échelle, d'opacité qui sont modifié aléatoirement et la rotation qui reprend
la donnée marquée dans le config.json*/

func (p *Particle)Changement(){

  x1 := rand.NewSource(time.Now().UnixNano())
  y1 := rand.New(x1)

    p.ColorBlue = y1.Float64()
    p.ColorRed = y1.Float64()
    p.ColorGreen = y1.Float64()

      var echelle float64 = y1.Float64()
    p.ScaleX = echelle
    p.ScaleY = echelle
    p.Opacity = y1.Float64()
    p.Rotation = p.Rotation + config.General.Rotation
  }

/* une fonction qui génére aléatoire une particule avec une définition
d'une vitesse, d'une position, d'une couleur, d'une taille,d'une rotation à 0,
d'une transparance et d'une durée de vie pour celle-ci */

func GenParticle() Particle{

  x1 := rand.NewSource(time.Now().UnixNano())
  y1 := rand.New(x1)

  var  PositionX float64
  var  PositionY float64

  if config.General.RandomSpawn{
  PositionX = float64(y1.Intn(int(config.General.WindowSizeX)))
  PositionY = float64(y1.Intn(int(config.General.WindowSizeY)))
  }else{
  PositionX = float64(config.General.SpawnX)
  PositionY = float64(config.General.SpawnY)
  }

  return Particle{
  PositionX: PositionX,
  PositionY: PositionY,
  SpeedX: y1.Float64()*float64(math.Pow(-1, float64(y1.Intn(2)))),
  SpeedY: y1.Float64()*float64(math.Pow(-1, float64(y1.Intn(2)))),
  ScaleX:    float64(y1.Intn(4)), ScaleY: float64(y1.Intn(4)),
  Rotation: 0,
  ColorRed: 1, ColorGreen: 0, ColorBlue:0,
  Opacity: 1,
  Dureevie : config.General.Dureevie}
}

/*une méthode qui rajoute des particules dans le tableau, les particles créé
viennent de la fonction GenParticle*/

  func (s *System)Add(){

    if s.DernierVivant < len(s.Content)-1{
      s.Content[s.DernierVivant+1] = GenParticle()
      s.DernierVivant++
    }else{
      s.Content=append(s.Content, GenParticle())
      s.DernierVivant ++
  }
  if config.General.ChangementActive{
    s.Content[s.DernierVivant].Changement()
  }
}

// fonction qui met à jour la position des particules

func(p *Particle)PositionUpdate(){
  if config.General.LimiteActive{

      if !p.Death{

        if p.PositionX < float64(config.General.WindowSizeX)+ float64(config.General.LimiteX) && p.PositionX > 0 - float64(config.General.LimiteX) && p.PositionY < float64(config.General.WindowSizeY)+ float64(config.General.LimiteY) && p.PositionY > 0 - float64(config.General.LimiteX) {
          p.PositionX = p.PositionX + p.SpeedX
          p.PositionY = p.PositionY + p.SpeedY
        }else{
          p.Death = true
        }
      }
    }else{
        if !p.Death{
            p.PositionX = p.PositionX + p.SpeedX
            p.PositionY = p.PositionY + p.SpeedY
        }
    }
  }
