package particles

import ("project-particles/config")


// Update mets à jour l'état du système de particules (c'est-à-dire l'état de
// chacune des particules) à chaque pas de temps. Elle est appellée exactement
// 60 fois par seconde (de manière régulière) par la fonction principale du
// projet.
// C'est à vous de développer cette fonction.

/* appelle toutes les méthodes qui sont dans le fichier "fonction.go" pour
mettre à jour pour chaque particules à chaque nouveau appel.
Pour pouvoir activer ou désactiver des extensions il faut aller dans le
config.json. */

func (s *System) Update() {

  for i:=0; i<=s.DernierVivant;i++{

    if config.General.Rebondis{
      s.Content[i].Rebondis()
    }

    if config.General.GraviteActive{
      s.Content[i].Gravitee()
    }

    if config.General.DureevieActive{
      s.Content[i].Vie()
    }

    if config.General.ChangementActive {
      s.Content[i].Changement()
    }

    s.Content[i].PositionUpdate()

    if s.Content[i].Death{
      s.Content[i], s.Content[s.DernierVivant] = s.Content[s.DernierVivant], s.Content[i]
      s.DernierVivant--
      i--
    }
  }


  s.actualSpawn += config.General.SpawnRate

  for s.actualSpawn >= 1{
    s.Add()
    s.actualSpawn = s.actualSpawn - 1
  }
}
